#!/usr/bin/python
# -*- coding: utf-8 -*-


# Allow printing with same syntax in Python 2/3
from __future__ import print_function

#import curses
import errno
import locale
import math
import optparse
import os
import select
import signal
import sys
import time
import errno
import pprint
import pwd
import stat
import struct
import time
import ctypes
import fnmatch
import platform
import re
import binascii
import threading
import commands
import dbus
import dbus.service
import dbus.mainloop.glib
import math
from gi.repository import GLib, GObject

VERSION = '0.6'

#m_running = True




# From http://git.kernel.org/?p=utils/util-linux-ng/util-linux-ng.git;a=blob;
#      f=configure.ac;h=770eb45ae85d32757fc3cff1d70a7808a627f9f7;hb=HEAD#l354
# i386 bit userspace under an x86_64 kernel will have its uname() appear as
# 'x86_64' but it will use the i386 syscall number, that's why we consider both
# the architecture name and the word size.
IOPRIO_GET_ARCH_SYSCALL = [
    ('alpha',       '*',  443),
    ('arm*',        '*',  315),
    ('i*86',        '*',  290),
    ('ia64*',       '*', 1275),
    ('parisc*',     '*',  268),
    ('powerpc*',    '*',  274),
    ('s390*',       '*',  283),
    ('sparc*',      '*',  218),
    ('sh*',         '*',  289),
    ('x86_64*', '32bit',  290),
    ('x86_64*', '64bit',  252),
]

IOPRIO_SET_ARCH_SYSCALL = [
    ('alpha',       '*',  442),
    ('arm*',        '*',  314),
    ('i*86',        '*',  289),
    ('ia64*',       '*', 1274),
    ('parisc*',     '*',  267),
    ('powerpc*',    '*',  273),
    ('s390*',       '*',  282),
    ('sparc*',      '*',  196),
    ('sh*',         '*',  288),
    ('x86_64*',  '32bit', 289),
    ('x86_64*',  '64bit', 251),
]

def find_ioprio_syscall_number(syscall_list):
    arch = os.uname()[4]
    bits = platform.architecture()[0]

    for candidate_arch, candidate_bits, syscall_nr in syscall_list:
        if fnmatch.fnmatch(arch, candidate_arch) and \
           fnmatch.fnmatch(bits, candidate_bits):
            return syscall_nr

class IoprioSetError(Exception):
    def __init__(self, err):
        try:
            self.err = os.strerror(err)
        except TypeError:
            self.err = err

__NR_ioprio_get = find_ioprio_syscall_number(IOPRIO_GET_ARCH_SYSCALL)
__NR_ioprio_set = find_ioprio_syscall_number(IOPRIO_SET_ARCH_SYSCALL)

try:
    ctypes_handle = ctypes.CDLL(None, use_errno=True)
except TypeError:
    ctypes_handle = ctypes.CDLL(None)

syscall = ctypes_handle.syscall

PRIORITY_CLASSES = [None, 'rt', 'be', 'idle']

IOPRIO_WHO_PROCESS = 1
IOPRIO_CLASS_SHIFT = 13
IOPRIO_PRIO_MASK = (1 << IOPRIO_CLASS_SHIFT) - 1

def ioprio_value(ioprio_class, ioprio_data):
    try:
        ioprio_class = PRIORITY_CLASSES.index(ioprio_class)
    except ValueError:
        ioprio_class = PRIORITY_CLASSES.index(None)
    return (ioprio_class << IOPRIO_CLASS_SHIFT) | ioprio_data

def ioprio_class(ioprio):
    return PRIORITY_CLASSES[ioprio >> IOPRIO_CLASS_SHIFT]

def ioprio_data(ioprio):
    return ioprio & IOPRIO_PRIO_MASK

sched_getscheduler = ctypes_handle.sched_getscheduler
SCHED_OTHER, SCHED_FIFO, SCHED_RR, SCHED_BATCH, SCHED_ISO, SCHED_IDLE = range(6)

getpriority = ctypes_handle.getpriority
PRIO_PROCESS = 0

def get_ioprio_from_sched(pid):
    scheduler = sched_getscheduler(pid)
    nice = getpriority(PRIO_PROCESS, pid)
    ioprio_nice = (nice + 20) / 5

    if scheduler in (SCHED_FIFO, SCHED_RR):
        return 'rt/%d' % ioprio_nice
    elif scheduler == SCHED_IDLE:
        return 'idle'
    else:
        return 'be/%d' % ioprio_nice

def myget(pid):
    if __NR_ioprio_get is None:
        return '?sys'

    ioprio = syscall(__NR_ioprio_get, IOPRIO_WHO_PROCESS, pid)
    if ioprio < 0:
        return '?err'

    prio_class = ioprio_class(ioprio)
    if not prio_class:
        return get_ioprio_from_sched(pid)
    if prio_class == 'idle':
        return prio_class
    return '%s/%d' % (prio_class, ioprio_data(ioprio))

def set_ioprio(which, who, ioprio_class, ioprio_data):
    if __NR_ioprio_set is None:
        raise IoprioSetError('No ioprio_set syscall found')

    ioprio_val = ioprio_value(ioprio_class, ioprio_data)
    ret = syscall(__NR_ioprio_set, which, who, ioprio_val, use_errno=True)
    if ret < 0:
        try:
            err = ctypes.get_errno()
        except AttributeError:
            err = 'Unknown error (errno support not available before Python2.6)'
        raise IoprioSetError(err)

def sort_key(key):
    if key[0] == '?':
        return -ord(key[1])

    if '/' in key:
        if key.startswith('rt/'):
            shift = 0
        elif key.startswith('be/'):
            shift = 1
        prio = int(key.split('/')[1])
    elif key == 'idle':
        shift = 2
        prio = 0

    return (1 << (shift * IOPRIO_CLASS_SHIFT)) + prio

def to_class_and_data(ioprio_str):
    if '/' in ioprio_str:
        split = ioprio_str.split('/')
        return (split[0], int(split[1]))
    elif ioprio_str == 'idle':
        return ('idle', 0)
    return (None, None)


#from iotop import ioprio, vmstat
#from iotop.netlink import Connection, NETLINK_GENERIC, U32Attr, NLM_F_REQUEST
#from iotop.genetlink import Controller, GeNlMessage
import os
import socket
import struct

try:
    # try to use python 2.5's netlink support
    _dummysock = socket.socket(socket.AF_NETLINK, socket.SOCK_RAW, 0)
    _dummysock.bind((0, 0))
    del _dummysock
    def _nl_bind(descriptor, addr):
        descriptor.bind(addr)
    def _nl_getsockname(descriptor):
        return descriptor.getsockname()
    def _nl_send(descriptor, msg):
        descriptor.send(msg)
    def _nl_recv(descriptor, bufs=16384):
        return descriptor.recvfrom(bufs)
except socket.error:
    # or fall back to the _netlink C module
    try:
        import _netlink
        def _nl_bind(descriptor, addr):
            _netlink.bind(descriptor.fileno(), addr[1])
        def _nl_getsockname(descriptor):
            return _netlink.getsockname(descriptor.fileno())
        def _nl_send(descriptor, msg):
            _netlink.send(descriptor.fileno(), msg)
        def _nl_recv(descriptor, bufs=16384):
            return _netlink.recvfrom(descriptor.fileno(), bufs)
    except ImportError:
        # or fall back to the ctypes module
        import ctypes

        libc = ctypes.CDLL(None)

        class SOCKADDR_NL(ctypes.Structure):
            _fields_ = [("nl_family", ctypes.c_ushort),
                        ("nl_pad",    ctypes.c_ushort),
                        ("nl_pid",    ctypes.c_int),
                        ("nl_groups", ctypes.c_int)]

        def _nl_bind(descriptor, addr):
            addr = SOCKADDR_NL(socket.AF_NETLINK, 0, os.getpid(), 0)
            return libc.bind(descriptor.fileno(),
                             ctypes.pointer(addr),
                             ctypes.sizeof(addr))

        def _nl_getsockname(descriptor):
            addr = SOCKADDR_NL(0, 0, 0, 0)
            len = ctypes.c_int(ctypes.sizeof(addr));
            libc.getsockname(descriptor.fileno(),
                             ctypes.pointer(addr),
                             ctypes.pointer(len))
            return addr.nl_pid, addr.nl_groups;

        def _nl_send(descriptor, msg):
            return libc.send(descriptor.fileno(), msg, len(msg), 0);

        def _nl_recv(descriptor, bufs=16384):
            addr = SOCKADDR_NL(0, 0, 0, 0)
            len = ctypes.c_int(ctypes.sizeof(addr))
            buf = ctypes.create_string_buffer(bufs)

            r = libc.recvfrom(descriptor.fileno(),
                              buf, bufs, 0,
                              ctypes.pointer(addr), ctypes.pointer(len))

            ret = ctypes.string_at(ctypes.pointer(buf), r)
            return ret, (addr.nl_pid, addr.nl_groups)


# flags
NLM_F_REQUEST  = 1
NLM_F_MULTI    = 2
NLM_F_ACK      = 4
NLM_F_ECHO     = 8

# types
NLMSG_NOOP     = 1
NLMSG_ERROR    = 2
NLMSG_DONE     = 3
NLMSG_OVERRUN  = 4
NLMSG_MIN_TYPE = 0x10

class Attr:
    def __init__(self, attr_type, data, *values):
        self.type = attr_type
        if len(values):
            self.data = struct.pack(data, *values)
        else:
            self.data = data

    def _dump(self):
        hdr = struct.pack("HH", len(self.data)+4, self.type)
        length = len(self.data)
        pad = ((length + 4 - 1) & ~3 ) - length
        return hdr + self.data + b'\0' * pad

    def __repr__(self):
        return '<Attr type %d, data "%s">' % (self.type, repr(self.data))

    def u16(self):
        return struct.unpack('H', self.data)[0]
    def s16(self):
        return struct.unpack('h', self.data)[0]
    def u32(self):
        return struct.unpack('I', self.data)[0]
    def s32(self):
        return struct.unpack('i', self.data)[0]
    def str(self):
        return self.data
    def nulstr(self):
        return self.data.split('\0')[0]
    def nested(self):
        return parse_attributes(self.data)

class StrAttr(Attr):
    def __init__(self, attr_type, data):
        Attr.__init__(self, attr_type, "%ds" % len(data), data.encode('utf-8'))

class NulStrAttr(Attr):
    def __init__(self, attr_type, data):
        Attr.__init__(self, attr_type, "%dsB" % len(data), data.encode('utf-8'), 0)

class U32Attr(Attr):
    def __init__(self, attr_type, val):
        Attr.__init__(self, attr_type, "I", val)

class U8Attr(Attr):
    def __init__(self, attr_type, val):
        Attr.__init__(self, attr_type, "B", val)

class Nested(Attr):
    def __init__(self, attr_type, attrs):
        self.attrs = attrs
        self.type = attr_type

    def _dump(self):
        contents = []
        for attr in self.attrs:
            contents.append(attr._dump())
        contents = ''.join(contents)
        length = len(contents)
        hdr = struct.pack("HH", length+4, self.type)
        return hdr + contents

NETLINK_ROUTE          = 0
NETLINK_UNUSED         = 1
NETLINK_USERSOCK       = 2
NETLINK_FIREWALL       = 3
NETLINK_INET_DIAG      = 4
NETLINK_NFLOG          = 5
NETLINK_XFRM           = 6
NETLINK_SELINUX        = 7
NETLINK_ISCSI          = 8
NETLINK_AUDIT          = 9
NETLINK_FIB_LOOKUP     = 10
NETLINK_CONNECTOR      = 11
NETLINK_NETFILTER      = 12
NETLINK_IP6_FW         = 13
NETLINK_DNRTMSG        = 14
NETLINK_KOBJECT_UEVENT = 15
NETLINK_GENERIC        = 16

class Message:
    def __init__(self, msg_type, flags=0, seq=-1, payload=None):
        self.type = msg_type
        self.flags = flags
        self.seq = seq
        self.pid = -1
        payload = payload or []
        if isinstance(payload, list):
            contents = []
            for attr in payload:
                contents.append(attr._dump())
            self.payload = b''.join(contents)
        else:
            self.payload = payload

    def send(self, conn):
        if self.seq == -1:
            self.seq = conn.seq()

        self.pid = conn.pid
        length = len(self.payload)

        hdr = struct.pack("IHHII", length + 4*4, self.type,
                          self.flags, self.seq, self.pid)
        conn.send(hdr + self.payload)

    def __repr__(self):
        return '<netlink.Message type=%d, pid=%d, seq=%d, flags=0x%x "%s">' % (
            self.type, self.pid, self.seq, self.flags, repr(self.payload))

class Connection:
    def __init__(self, nltype, groups=0, unexpected_msg_handler=None):
        self.descriptor = socket.socket(socket.AF_NETLINK,
                                        socket.SOCK_RAW, nltype)
        self.descriptor.setsockopt(socket.SOL_SOCKET, socket.SO_SNDBUF, 65536)
        self.descriptor.setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, 65536)
        _nl_bind(self.descriptor, (0, groups))
        self.pid, self.groups = _nl_getsockname(self.descriptor)
        self._seq = 0
        self.unexpected = unexpected_msg_handler
    def send(self, msg):
        _nl_send(self.descriptor, msg)
    def recv(self):
        contents, (nlpid, nlgrps) = _nl_recv(self.descriptor)
        # XXX: python doesn't give us message flags, check
        #      len(contents) vs. msglen for TRUNC
        msglen, msg_type, flags, seq, pid = struct.unpack("IHHII",
                                                          contents[:16])
        msg = Message(msg_type, flags, seq, contents[16:])
        msg.pid = pid
        if msg.type == NLMSG_ERROR:
            errno = -struct.unpack("i", msg.payload[:4])[0]
            if errno != 0:
                err = OSError("Netlink error: %s (%d)" % (
                                                     os.strerror(errno), errno))
                err.errno = errno
                raise err
        return msg
    def seq(self):
        self._seq += 1
        return self._seq

def parse_attributes(data):
    attrs = {}
    while len(data):
        attr_len, attr_type = struct.unpack("HH", data[:4])
        attrs[attr_type] = Attr(attr_type, data[4:attr_len])
        attr_len = ((attr_len + 4 - 1) & ~3 )
        data = data[attr_len:]
    return attrs

class VmStat(object):
    def __init__(self):
        self.vmstat_file = open('/proc/vmstat')
        self.vmstat = self.read()

    def read(self):
        def extract(line):
            return int(line.split()[1]) * 1024

        for line in self.vmstat_file:
            if line.startswith('pgpgin '):
                pgpgin = extract(line)
                break

        for line in self.vmstat_file:
            if line.startswith('pgpgout '):
                pgpgout = extract(line)
                break

        self.vmstat_file.seek(0)
        return pgpgin, pgpgout

    def delta(self):
        now = self.read()
        delta = now[0] - self.vmstat[0], now[1] - self.vmstat[1]
        self.vmstat = now
        return delta








CTRL_CMD_UNSPEC       = 0
CTRL_CMD_NEWFAMILY    = 1
CTRL_CMD_DELFAMILY    = 2
CTRL_CMD_GETFAMILY    = 3
CTRL_CMD_NEWOPS       = 4
CTRL_CMD_DELOPS       = 5
CTRL_CMD_GETOPS       = 6

CTRL_ATTR_UNSPEC      = 0
CTRL_ATTR_FAMILY_ID   = 1
CTRL_ATTR_FAMILY_NAME = 2
CTRL_ATTR_VERSION     = 3
CTRL_ATTR_HDRSIZE     = 4
CTRL_ATTR_MAXATTR     = 5
CTRL_ATTR_OPS         = 6

class GenlHdr:
    def __init__(self, cmd, version = 0):
        self.cmd = cmd
        self.version = version
    def _dump(self):
        return struct.pack("BBxx", self.cmd, self.version)

def _genl_hdr_parse(data):
    return GenlHdr(*struct.unpack("BBxx", data))

GENL_ID_CTRL        = NLMSG_MIN_TYPE

class GeNlMessage(Message):
    def __init__(self, family, cmd, attrs=[], flags=0):
        self.cmd = cmd
        self.attrs = attrs
        self.family = family
        Message.__init__(self, family, flags=flags,
                         payload=[GenlHdr(self.cmd)]+attrs)

    @staticmethod
    def recv(conn):
        msg = conn.recv()
        packet = msg.payload
        hdr = _genl_hdr_parse(packet[:4])

        genlmsg = GeNlMessage(msg.type, hdr.cmd, [], msg.flags)
        genlmsg.attrs = parse_attributes(packet[4:])
        genlmsg.version = hdr.version

        return genlmsg

class Controller:
    def __init__(self, conn):
        self.conn = conn
    def get_family_id(self, family):
        a = NulStrAttr(CTRL_ATTR_FAMILY_NAME, family)
        m = GeNlMessage(GENL_ID_CTRL, CTRL_CMD_GETFAMILY,
                        flags=NLM_F_REQUEST, attrs=[a])
        m.send(self.conn)
        m = GeNlMessage.recv(self.conn)
        return m.attrs[CTRL_ATTR_FAMILY_ID].u16()



class DumpableObject(object):
    """Base class for all objects that allows easy introspection when printed"""
    def __repr__(self):
        return '%s: %s>' % (str(type(self))[:-1], pprint.pformat(self.__dict__))


#
# Interesting fields in a taskstats output
#

class Stats(DumpableObject):
    members_offsets = [
        ('blkio_delay_total', 40),
        ('swapin_delay_total', 56),
        ('read_bytes', 248),
        ('write_bytes', 256),
        ('cancelled_write_bytes', 264)
    ]

    has_blkio_delay_total = False

    def __init__(self, task_stats_buffer):
        sd = self.__dict__
        for name, offset in Stats.members_offsets:
            data = task_stats_buffer[offset:offset + 8]
            sd[name] = struct.unpack('Q', data)[0]

        # This is a heuristic to detect if CONFIG_TASK_DELAY_ACCT is enabled in
        # the kernel.
        if not Stats.has_blkio_delay_total:
            Stats.has_blkio_delay_total = self.blkio_delay_total != 0

    def accumulate(self, other_stats, destination, coeff=1):
        """Update destination from operator(self, other_stats)"""
        dd = destination.__dict__
        sd = self.__dict__
        od = other_stats.__dict__
        for member, offset in Stats.members_offsets:
            dd[member] = sd[member] + coeff * od[member]

    def delta(self, other_stats, destination):
        """Update destination with self - other_stats"""
        return self.accumulate(other_stats, destination, coeff=-1)

    def is_all_zero(self):
        sd = self.__dict__
        for name, offset in Stats.members_offsets:
            if sd[name] != 0:
                return False
        return True

    @staticmethod
    def build_all_zero():
        stats = Stats.__new__(Stats)
        std = stats.__dict__
        for name, offset in Stats.members_offsets:
            std[name] = 0
        return stats

#
# Netlink usage for taskstats
#

TASKSTATS_CMD_GET = 1
TASKSTATS_CMD_ATTR_PID = 1
TASKSTATS_TYPE_AGGR_PID = 4
TASKSTATS_TYPE_PID = 1
TASKSTATS_TYPE_STATS = 3

class TaskStatsNetlink(object):
    # Keep in sync with format_stats() and pinfo.did_some_io()

    def __init__(self, options):
        self.options = options
        self.connection = Connection(NETLINK_GENERIC)
        controller = Controller(self.connection)
        self.family_id = controller.get_family_id('TASKSTATS')

    def build_request(self, tid):
        return GeNlMessage(self.family_id, cmd=TASKSTATS_CMD_GET,
                           attrs=[U32Attr(TASKSTATS_CMD_ATTR_PID, tid)],
                           flags=NLM_F_REQUEST)

    def get_single_task_stats(self, thread):
        thread.task_stats_request.send(self.connection)
        try:
            reply = GeNlMessage.recv(self.connection)
        except OSError as e:
            if e.errno == errno.ESRCH:
                # OSError: Netlink error: No such process (3)
                return
            raise
        for attr_type, attr_value in reply.attrs.items():
            if attr_type == TASKSTATS_TYPE_AGGR_PID:
                reply = attr_value.nested()
                break
        else:
            return
        taskstats_data = reply[TASKSTATS_TYPE_STATS].data
        if len(taskstats_data) < 272:
            # Short reply
            return
        taskstats_version = struct.unpack('H', taskstats_data[:2])[0]
        assert taskstats_version >= 4
        return Stats(taskstats_data)

#
# PIDs manipulations
#

def find_uids(options):
    """Build options.uids from options.users by resolving usernames to UIDs"""
    options.uids = []
    error = False
    for u in options.users or []:
        try:
            uid = int(u)
        except ValueError:
            try:
                passwd = pwd.getpwnam(u)
            except KeyError:
                print('Unknown user:', u, file=sys.stderr)
                error = True
            else:
                uid = passwd.pw_uid
        if not error:
            options.uids.append(uid)
    if error:
        sys.exit(1)


def parse_proc_pid_status(pid):
    result_dict = {}
    try:
        for line in open('/proc/%d/status' % pid):
            key, value = line.split(':\t', 1)
            result_dict[key] = value.strip()
    except IOError:
        pass  # No such process
    return result_dict


def safe_utf8_decode(s):
    try:
        return s.decode('utf-8')
    except UnicodeDecodeError:
        return s.encode('string_escape')
    except AttributeError:
        return s

class ThreadInfo(DumpableObject):
    """Stats for a single thread"""
    def __init__(self, tid, taskstats_connection):
        self.tid = tid
        self.mark = True
        self.stats_total = None
        self.stats_delta = Stats.__new__(Stats)
        self.task_stats_request = taskstats_connection.build_request(tid)

    def get_ioprio(self):
        return myget(self.tid)

    def set_ioprio(self, ioprio_class, ioprio_data):
        return set_ioprio(IOPRIO_WHO_PROCESS, self.tid,
                                 ioprio_class, ioprio_data)

    def update_stats(self, stats):
        if not self.stats_total:
            self.stats_total = stats
        stats.delta(self.stats_total, self.stats_delta)
        self.stats_total = stats


class ProcessInfo(DumpableObject):
    """Stats for a single process (a single line in the output): if
    options.processes is set, it is a collection of threads, otherwise a single
    thread."""
    def __init__(self, pid):
        self.pid = pid
        self.uid = None
        self.user = None
        self.threads = {} # {tid: ThreadInfo}
        self.stats_delta = Stats.build_all_zero()
        self.stats_accum = Stats.build_all_zero()
        self.stats_accum_timestamp = time.time()

    def is_monitored(self, options):
        if (options.pids and not options.processes and
            self.pid not in options.pids):
            # We only monitor some threads, not this one
            return False

        if options.uids and self.get_uid() not in options.uids:
            # We only monitor some users, not this one
            return False

        return True

    def get_uid(self):
        if self.uid:
            return self.uid
        # uid in (None, 0) means either we don't know the UID yet or the process
        # runs as root so it can change its UID. In both cases it means we have
        # to find out its current UID.
        try:
            uid = os.stat('/proc/%d' % self.pid)[stat.ST_UID]
        except OSError:
            # The process disappeared
            uid = None
        if uid != self.uid:
            # Maybe the process called setuid()
            self.user = None
            self.uid = uid
        return uid

    def get_user(self):
        uid = self.get_uid()
        if uid is not None and not self.user:
            try:
                self.user = safe_utf8_decode(pwd.getpwuid(uid).pw_name)
            except (KeyError, AttributeError):
                self.user = str(uid)
        return self.user or '{none}'

    def get_cmdline(self):
        # A process may exec, so we must always reread its cmdline
        try:
            proc_cmdline = open('/proc/%d/cmdline' % self.pid)
            cmdline = proc_cmdline.read(4096)
        except IOError:
            return '{no such process}'
        proc_status = parse_proc_pid_status(self.pid)
        if not cmdline:
            # Probably a kernel thread, get its name from /proc/PID/status
            proc_status_name = proc_status.get('Name', '')
            if proc_status_name:
                proc_status_name = '[%s]' % proc_status_name
            else:
                proc_status_name = '{no name}'
            return proc_status_name
        suffix = ''
        tgid = int(proc_status.get('Tgid', self.pid))
        if tgid != self.pid:
            # Not the main thread, maybe it has a custom name
            tgid_name = parse_proc_pid_status(tgid).get('Name', '')
            thread_name = proc_status.get('Name', '')
            if thread_name != tgid_name:
                suffix += ' [%s]' % thread_name
        parts = cmdline.split('\0')
        if parts[0].startswith('/'):
            first_command_char = parts[0].rfind('/') + 1
            parts[0] = parts[0][first_command_char:]
        cmdline = ' '.join(parts).strip()
        return safe_utf8_decode(cmdline + suffix)

    def did_some_io(self, accumulated):
        if accumulated:
            return not self.stats_accum.is_all_zero()
        for t in self.threads.values():
            if not t.stats_delta.is_all_zero():
                return True
        return False

    def get_ioprio(self):
        priorities = set(t.get_ioprio() for t in self.threads.values())
        if len(priorities) == 1:
            return priorities.pop()
        return '?dif'

    def set_ioprio(self, ioprio_class, ioprio_data):
        for thread in self.threads.values():
            thread.set_ioprio(ioprio_class, ioprio_data)

    def ioprio_sort_key(self):
        return sort_key(self.get_ioprio())

    def get_thread(self, tid, taskstats_connection):
        thread = self.threads.get(tid, None)
        if not thread:
            thread = ThreadInfo(tid, taskstats_connection)
            self.threads[tid] = thread
        return thread

    def update_stats(self):
        stats_delta = Stats.build_all_zero()
        for tid, thread in self.threads.items():
            if not thread.mark:
                stats_delta.accumulate(thread.stats_delta, stats_delta)
        self.threads = dict([(tid, thread) for tid, thread in
                             self.threads.items() if not thread.mark])

        nr_threads = len(self.threads)
        if not nr_threads:
            return False

        stats_delta.blkio_delay_total /= nr_threads
        stats_delta.swapin_delay_total /= nr_threads

        self.stats_delta = stats_delta
        self.stats_accum.accumulate(self.stats_delta, self.stats_accum)

        return True

class ProcessList(DumpableObject):
    def __init__(self, taskstats_connection, options):
        # {pid: ProcessInfo}
        self.processes = {}
        self.taskstats_connection = taskstats_connection
        self.options = options
        self.timestamp = time.time()
        self.vmstat = VmStat()

        # A first time as we are interested in the delta
        self.update_process_counts()

    def get_process(self, pid):
        """Either get the specified PID from self.processes or build a new
        ProcessInfo if we see this PID for the first time"""
        process = self.processes.get(pid, None)
        if not process:
            process = ProcessInfo(pid)
            self.processes[pid] = process

        if process.is_monitored(self.options):
            return process

    def list_tgids(self):
        if self.options.pids:
            return self.options.pids

        tgids = os.listdir('/proc')
        if self.options.processes:
            return [int(tgid) for tgid in tgids if '0' <= tgid[0] <= '9']

        tids = []
        for tgid in tgids:
            if '0' <= tgid[0] <= '9':
                try:
                    tids.extend(map(int, os.listdir('/proc/' + tgid + '/task')))
                except OSError:
                    # The PID went away
                    pass
        return tids

    def list_tids(self, tgid):
        if not self.options.processes:
            return [tgid]

        try:
            tids = list(map(int, os.listdir('/proc/%d/task' % tgid)))
        except OSError:
            return []

        if self.options.pids:
            tids = list(set(self.options.pids).intersection(set(tids)))

        return tids

    def update_process_counts(self):
        new_timestamp = time.time()
        self.duration = new_timestamp - self.timestamp
        self.timestamp = new_timestamp

        total_read = total_write = 0

        for tgid in self.list_tgids():
            process = self.get_process(tgid)
            if not process:
                continue
            for tid in self.list_tids(tgid):
                thread = process.get_thread(tid, self.taskstats_connection)
                stats = self.taskstats_connection.get_single_task_stats(thread)
                if stats:
                    thread.update_stats(stats)
                    delta = thread.stats_delta
                    total_read += delta.read_bytes
                    total_write += delta.write_bytes
                    thread.mark = False
        return (total_read, total_write), self.vmstat.delta()

    def refresh_processes(self):
        for process in self.processes.values():
            for thread in process.threads.values():
                thread.mark = True

        total_read_and_write = self.update_process_counts()

        self.processes = dict([(pid, process) for pid, process in
                               self.processes.items() if
                               process.update_stats()])

        return total_read_and_write

    def clear(self):
        self.processes = {}




#
# Utility functions for the UI
#

UNITS = ['B', 'K', 'M', 'G', 'T', 'P', 'E']

def human_size(size):
    if size > 0:
        sign = ''
    elif size < 0:
        sign = '-'
        size = -size
    else:
        return '0.00 B'

    expo = int(math.log(size / 2, 2) / 10)
    return '%s%.2f %s' % (sign, (float(size) / (1 << (10 * expo))), UNITS[expo])

def format_size(options, bytes):
    if options.kilobytes:
        return '%.2f K' % (bytes / 1024.0)
    return human_size(bytes)

def format_bandwidth(options, size, duration):
    return format_size(options, size and float(size) / duration) + '/s'

def format_stats(options, process, duration):
    # Keep in sync with TaskStatsNetlink.members_offsets and
    # IOTopUI.get_data(self)
    def delay2percent(delay): # delay in ns, duration in s
        return '%.2f %%' % min(99.99, delay / (duration * 10000000.0))
#    if options.accumulated:
#        stats = process.stats_accum
#        display_format = lambda size, duration: format_size(options, size)
#        duration = time.time() - process.stats_accum_timestamp
#    else:
    stats = process.stats_delta
    display_format = lambda size, duration: format_bandwidth(
                                                        options, size, duration)
    io_delay = delay2percent(stats.blkio_delay_total)
    swapin_delay = delay2percent(stats.swapin_delay_total)
    read_bytes = display_format(stats.read_bytes, duration)
    written_bytes = stats.write_bytes - stats.cancelled_write_bytes
    written_bytes = max(0, written_bytes)
    write_bytes = display_format(written_bytes, duration)
    return io_delay, swapin_delay, read_bytes, write_bytes

def get_max_pid_width():
    try:
        return len(open('/proc/sys/kernel/pid_max').read().strip())
    except Exception as e:
        print(e)
        # Reasonable default in case something fails
        return 5

MAX_PID_WIDTH = get_max_pid_width()

#
# UI Exceptions
#

#class CancelInput(Exception): pass
#class InvalidInt(Exception): pass
#class InvalidPid(Exception): pass
#class InvalidTid(Exception): pass
#class InvalidIoprioData(Exception): pass

#
# The UI
#

class IOTopUI(object):
    # key, reverse
    sorting_keys = [
        (lambda p, s: p.pid, False),
        (lambda p, s: p.ioprio_sort_key(), False),
        (lambda p, s: p.get_user(), False),
        (lambda p, s: s.read_bytes, True),
        (lambda p, s: s.write_bytes - s.cancelled_write_bytes, True),
        (lambda p, s: s.swapin_delay_total, True),
        # The default sorting (by I/O % time) should show processes doing
        # only writes, without waiting on them
        (lambda p, s: s.blkio_delay_total or
                      int(not(not(s.read_bytes or s.write_bytes))), True),
        (lambda p, s: p.get_cmdline(), False),
    ]

    def __init__(self, process_list, options, interface):
        self.process_list = process_list
        self.options = options
        self.interface = interface
        self.sorting_key = 6
        self.sorting_reverse = IOTopUI.sorting_keys[self.sorting_key][1]
#        if not self.options.batch:
##            self.win = win
##            self.resize()
#            try:
#                curses.use_default_colors()
#                curses.start_color()
#                curses.curs_set(0)
#            except curses.error:
#                # This call can fail with misconfigured terminals, for example
#                # TERM=xterm-color. This is harmless
#                pass

#    def resize(self):
#        self.height, self.width = self.win.getmaxyx()


#    def timer_handler(self, name):
#        print("timer_handler:", name)
#        iterations = 0
#        total, actual = self.process_list.refresh_processes()
#        self.refresh_display(iterations == 0, total, actual, self.process_list.duration)

    def timer_handler(self):
        iterations = 0
        total, actual = self.process_list.refresh_processes()
        self.refresh_display(iterations == 0, total, actual, self.process_list.duration)
        return True

    def run(self):
#        t = threading.Timer(self.options.delay_seconds, timer_handler, ("kylin",))
#        t.start()
        GObject.timeout_add(self.options.delay_seconds * 1000, self.timer_handler)

#        iterations = 0
##        poll = select.poll()
##        if not self.options.batch:
##        poll.register(sys.stdin.fileno(), select.POLLIN|select.POLLPRI)
##        while self.options.iterations is None or \
##              iterations < self.options.iterations:
#        while m_running:
#            if m_running == False:
#                break
#            total, actual = self.process_list.refresh_processes()
#            self.refresh_display(iterations == 0, total, actual, self.process_list.duration)
#            if m_running == False:
#                break
#            time.sleep(self.options.delay_seconds)
##            if self.options.iterations is not None:
##                iterations += 1
##                if iterations >= self.options.iterations:
##                    break
##            elif iterations == 0:
##                iterations = 1

##            try:
##                events = poll.poll(self.options.delay_seconds * 1000.0)
##            except select.error as e:
##                if e.args and e.args[0] == errno.EINTR:
##                    events = []
##                else:
##                    raise
##            for (fd, event) in events:
##                if event & (select.POLLERR | select.POLLHUP):
##                    sys.exit(1)
##            if not self.options.batch:
##                self.resize()
##            if events:
##                key = self.win.getch()
##                self.handle_key(key)

    def reverse_sorting(self):
        self.sorting_reverse = not self.sorting_reverse

#    def adjust_sorting_key(self, delta):
#        orig_sorting_key = self.sorting_key
#        self.sorting_key += delta
#        self.sorting_key = max(0, self.sorting_key)
#        self.sorting_key = min(len(IOTopUI.sorting_keys) - 1, self.sorting_key)
#        if orig_sorting_key != self.sorting_key:
#            self.sorting_reverse = IOTopUI.sorting_keys[self.sorting_key][1]

    # I wonder if switching to urwid for the display would be better here

#    def prompt_str(self, prompt, default=None, empty_is_cancel=True):
##        self.win.hline(1, 0, ord(' ') | curses.A_NORMAL, self.width)
##        self.win.addstr(1, 0, prompt, curses.A_BOLD)
##        self.win.refresh()
#        curses.echo()
#        curses.curs_set(1)
#        inp = self.win.getstr(1, len(prompt))
#        curses.curs_set(0)
#        curses.noecho()
#        if inp not in (None, ''):
#            return inp
#        if empty_is_cancel:
#            raise CancelInput()
#        return default

#    def prompt_int(self, prompt, default = None, empty_is_cancel = True):
#        inp = self.prompt_str(prompt, default, empty_is_cancel)
#        try:
#            return int(inp)
#        except ValueError:
#            raise InvalidInt()

#    def prompt_pid(self):
#        try:
#            return self.prompt_int('PID to ionice: ')
#        except InvalidInt:
#            raise InvalidPid()
#        except CancelInput:
#            raise

#    def prompt_tid(self):
#        try:
#            return self.prompt_int('TID to ionice: ')
#        except InvalidInt:
#            raise InvalidTid()
#        except CancelInput:
#            raise

#    def prompt_data(self, ioprio_data):
#        try:
#            if ioprio_data is not None:
#                inp = self.prompt_int('I/O priority data (0-7, currently %s): '
#                                      % ioprio_data, ioprio_data, False)
#            else:
#                inp = self.prompt_int('I/O priority data (0-7): ', None, False)
#        except InvalidInt:
#            raise InvalidIoprioData()
#        if inp < 0 or inp > 7:
#            raise InvalidIoprioData()
#        return inp

#    def prompt_set(self, prompt, display_list, ret_list, selected):
#        try:
#            selected = ret_list.index(selected)
#        except ValueError:
#            selected = -1
#        set_len = len(display_list) - 1
#        while True:
##            self.win.hline(1, 0, ord(' ') | curses.A_NORMAL, self.width)
##            self.win.insstr(1, 0, prompt, curses.A_BOLD)
#            offset = len(prompt)
#            for i, item in enumerate(display_list):
#                display = ' %s ' % item
#                if i is selected:
#                    attr = curses.A_REVERSE
#                else:
#                    attr = curses.A_NORMAL
##                self.win.insstr(1, offset, display, attr)
#                offset += len(display)
##            while True:
##                key = self.win.getch()
##                if key in (curses.KEY_LEFT, ord('l')) and selected > 0:
##                    selected -= 1
##                    break
##                elif key in (curses.KEY_RIGHT, ord('r')) and selected < set_len:
##                    selected += 1
##                    break
##                elif key in (curses.KEY_ENTER, ord('\n'), ord('\r')):
##                    return ret_list[selected]
##                elif key in (27, curses.KEY_CANCEL, curses.KEY_CLOSE,
##                             curses.KEY_EXIT, ord('q'), ord('Q')):
##                    raise CancelInput()

#    def prompt_class(self, ioprio_class=None):
#        prompt = 'I/O priority class: '
#        classes_prompt = ['Real-time', 'Best-effort', 'Idle']
#        classes_ret = ['rt', 'be', 'idle']
#        if ioprio_class is None:
#            ioprio_class = 2
#        inp = self.prompt_set(prompt, classes_prompt, classes_ret, ioprio_class)
#        return inp

#    def prompt_error(self, error = 'Error!'):
##        self.win.hline(1, 0, ord(' ') | curses.A_NORMAL, self.width)
##        self.win.insstr(1, 0, '  %s  ' % error, curses.A_REVERSE)
##        self.win.refresh()
#        time.sleep(1)

#    def prompt_clear(self):
#        pass
#        self.win.hline(1, 0, ord(' ') | curses.A_NORMAL, self.width)
#        self.win.refresh()

#    def handle_key(self, key):
#        def toggle_accumulated():
#            self.options.accumulated ^= True
#        def toggle_only_io():
#            self.options.only ^= True
#        def toggle_processes():
#            self.options.processes ^= True
#            self.process_list.clear()
#            self.process_list.refresh_processes()
#        def ionice():
#            try:
#                if self.options.processes:
#                    pid = self.prompt_pid()
#                    exec_unit = self.process_list.get_process(pid)
#                else:
#                    tid = self.prompt_tid()
#                    exec_unit = ThreadInfo(tid,
#                                         self.process_list.taskstats_connection)
#                ioprio_value = exec_unit.get_ioprio()
#                (ioprio_class, ioprio_data) = \
#                                          to_class_and_data(ioprio_value)
#                ioprio_class = self.prompt_class(ioprio_class)
#                if ioprio_class == 'idle':
#                    ioprio_data = 0
#                else:
#                    ioprio_data = self.prompt_data(ioprio_data)
#                exec_unit.set_ioprio(ioprio_class, ioprio_data)
#                self.process_list.clear()
#                self.process_list.refresh_processes()
#            except IoprioSetError as e:
#                self.prompt_error('Error setting I/O priority: %s' % e.err)
#            except InvalidPid:
#                self.prompt_error('Invalid process id!')
#            except InvalidTid:
#                self.prompt_error('Invalid thread id!')
#            except InvalidIoprioData:
#                self.prompt_error('Invalid I/O priority data!')
#            except InvalidInt:
#                self.prompt_error('Invalid integer!')
#            except CancelInput:
#                self.prompt_clear()
#            else:
#                self.prompt_clear()

#        key_bindings = {
#            ord('q'):
#                lambda: sys.exit(0),
#            ord('Q'):
#                lambda: sys.exit(0),
#            ord('r'):
#                lambda: self.reverse_sorting(),
#            ord('R'):
#                lambda: self.reverse_sorting(),
#            ord('a'):
#                toggle_accumulated,
#            ord('A'):
#                toggle_accumulated,
#            ord('o'):
#                toggle_only_io,
#            ord('O'):
#                toggle_only_io,
#            ord('p'):
#                toggle_processes,
#            ord('P'):
#                toggle_processes,
#            ord('i'):
#                ionice,
#            ord('I'):
#                ionice,
#            curses.KEY_LEFT:
#                lambda: self.adjust_sorting_key(-1),
#            curses.KEY_RIGHT:
#                lambda: self.adjust_sorting_key(1),
#            curses.KEY_HOME:
#                lambda: self.adjust_sorting_key(-len(IOTopUI.sorting_keys)),
#            curses.KEY_END:
#                lambda: self.adjust_sorting_key(len(IOTopUI.sorting_keys))
#        }

#        action = key_bindings.get(key, lambda: None)
#        action()

    def get_data(self):
        def format(p):
            stats = format_stats(self.options, p, self.process_list.duration)
            io_delay, swapin_delay, read_bytes, write_bytes = stats
            if Stats.has_blkio_delay_total:
                delay_stats = '%7s %7s ' % (swapin_delay, io_delay)
            else:
                delay_stats = ' ?unavailable?  '
            pid_format = '%%%dd' % MAX_PID_WIDTH
            line = (pid_format + ' %4s %-8s %11s %11s %s') % (
                p.pid, p.get_ioprio(), p.get_user()[:8], read_bytes,
                write_bytes, delay_stats)
            cmdline = p.get_cmdline()
#            if not self.options.batch:
#                remaining_length = self.width - len(line)
#                if 2 < remaining_length < len(cmdline):
#                    len1 = (remaining_length - 1) // 2
#                    offset2 = -(remaining_length - len1 - 1)
#                    cmdline = cmdline[:len1] + '~' + cmdline[offset2:]
            line += cmdline
#            if not self.options.batch:
#                line = line[:self.width]
            return line

        def should_format(p):
            return not self.options.only or \
                   p.did_some_io(self.options.accumulated)

        processes = list(filter(should_format, self.process_list.processes.values()))
        key = IOTopUI.sorting_keys[self.sorting_key][0]
        if self.options.accumulated:
            stats_lambda = lambda p: p.stats_accum
        else:
            stats_lambda = lambda p: p.stats_delta
        processes.sort(key=lambda p: key(p, stats_lambda(p)), reverse=self.sorting_reverse)#lixiang TODO
#        if not self.options.batch:
#            del processes[self.height - 2:]
        return list(map(format, processes))

    def refresh_display(self, first_time, total, actual, duration):
        summary = [
                'Total DISK READ : %s | Total DISK WRITE : %s' % (
                format_bandwidth(self.options, total[0], duration).rjust(14),
                format_bandwidth(self.options, total[1], duration).rjust(14)),
                'Actual DISK READ: %s | Actual DISK WRITE: %s' % (
                format_bandwidth(self.options, actual[0], duration).rjust(14),
                format_bandwidth(self.options, actual[1], duration).rjust(14))
        ]

        self.interface.sendTotalAndActual(format_bandwidth(self.options, total[0], duration).rjust(14), format_bandwidth(self.options, total[1], duration).rjust(14), format_bandwidth(self.options, actual[0], duration).rjust(14), format_bandwidth(self.options, actual[1], duration).rjust(14))

        pid = max(0, (MAX_PID_WIDTH - 3)) * ' '
        if self.options.processes:
            pid += 'PID'
        else:
            pid += 'TID'
#        titles = [pid, '  PRIO', '  USER', '     DISK READ', '  DISK WRITE',
#                  '  SWAPIN', '      IO', '    COMMAND']
        lines = self.get_data()
        self.interface.sendIoInfos(lines)
#        print ("lines:", lines)

#        print ("Total DISK READ:", format_bandwidth(self.options, total[0], duration).rjust(14));
#        print ("Total DISK WRITE:", format_bandwidth(self.options, total[1], duration).rjust(14));
#        print ("Actual DISK READ:", format_bandwidth(self.options, actual[0], duration).rjust(14));
#        print ("Actual DISK WRITE:", format_bandwidth(self.options, actual[1], duration).rjust(14));


#        if self.options.time:
#            titles = ['    TIME'] + titles
#            current_time = time.strftime('%H:%M:%S ')
#            lines = [current_time + l for l in lines]
#            summary = [current_time + s for s in summary]
#        if self.options.batch:
#            if self.options.quiet <= 2:
#                for s in summary:
#                    print(s)
#                if self.options.quiet <= int(first_time):
#                    print(''.join(titles))
#            for l in lines:
#                print(l)
#            sys.stdout.flush()
#        else:
#            self.win.erase()
#            for i, s in enumerate(summary):
#                self.win.addstr(i, 0, s[:self.width])
#            self.win.hline(len(summary), 0, ord(' ') | curses.A_REVERSE,
#                           self.width)
#            remaining_cols = self.width
#            for i in range(len(titles)):
#                attr = curses.A_REVERSE
#                title = titles[i]
#                if i == self.sorting_key:
#                    title = title[1:]
#                if i == self.sorting_key:
#                    attr |= curses.A_BOLD
#                    title += self.sorting_reverse and '>' or '<'
#                title = title[:remaining_cols]
#                remaining_cols -= len(title)
#                self.win.addstr(title, attr)
#            if Stats.has_blkio_delay_total:
#                status_msg = None
#            else:
#                status_msg = ('CONFIG_TASK_DELAY_ACCT not enabled in kernel, '
#                              'cannot determine SWAPIN and IO %')
#            num_lines = min(len(lines), self.height - 2 - int(bool(status_msg)))
#            for i in range(num_lines):
#                try:
#                    def print_line(line):
#                        self.win.addstr(i + len(summary) + 1, 0, line)
#                    try:
#                        print_line(lines[i])
#                    except UnicodeEncodeError:
#                        # Python2: 'ascii' codec can't encode character ...
#                        # http://bugs.debian.org/708252
#                        print_line(lines[i].encode('utf-8'))
#                except curses.error:
#                    pass
#            if status_msg:
#                self.win.insstr(self.height - len(summary), 0, status_msg,
#                                curses.A_BOLD)
#            self.win.refresh()


def run_iotop_window(options, interface):
#    def clean_exit(*args, **kwargs):
#        sys.exit(0)
#    signal.signal(signal.SIGINT, clean_exit)
#    signal.signal(signal.SIGTERM, clean_exit)
#    if options.batch:
#        signal.signal(signal.SIGPIPE, signal.SIG_DFL)
#    else:
#        def clean_exit(*args, **kwargs):
#            sys.exit(0)
#        signal.signal(signal.SIGINT, clean_exit)
#        signal.signal(signal.SIGTERM, clean_exit)
    taskstats_connection = TaskStatsNetlink(options)
    process_list = ProcessList(taskstats_connection, options)
    ui = IOTopUI(process_list, options, interface)
    ui.run()

def run_iotop(options, interface):
    try:
        run_iotop_window(options, interface)
#        return curses.wrapper(run_iotop_window, options)
#        if options.batch:
#            return run_iotop_window(None, options)
#        else:
#            return curses.wrapper(run_iotop_window, options)
    except OSError as e:
        if e.errno == errno.EPERM:
            print(e, file=sys.stderr)
            print('''
The Linux kernel interfaces that iotop relies on now require root priviliges
or the NET_ADMIN capability. This change occured because a security issue
(CVE-2011-2494) was found that allows leakage of sensitive data across user
boundaries. If you require the ability to run iotop as a non-root user, please
configure sudo to allow you to run iotop as root.

Please do not file bugs on iotop about this.''', file=sys.stderr)
            sys.exit(1)
        else:
            raise

#
# Profiling
#

#def _profile(continuation):
#    prof_file = 'iotop.prof'
#    try:
#        import cProfile
#        import pstats
#        print('Profiling using cProfile')
#        cProfile.runctx('continuation()', globals(), locals(), prof_file)
#        stats = pstats.Stats(prof_file)
#    except ImportError:
#        import hotshot
#        import hotshot.stats
#        prof = hotshot.Profile(prof_file, lineevents=1)
#        print('Profiling using hotshot')
#        prof.runcall(continuation)
#        prof.close()
#        stats = hotshot.stats.load(prof_file)
#    stats.strip_dirs()
#    stats.sort_stats('time', 'calls')
#    stats.print_stats(50)
#    stats.print_callees(50)
#    os.remove(prof_file)

#
# Main program
#

USAGE = '''%s [OPTIONS]

DISK READ and DISK WRITE are the block I/O bandwidth used during the sampling
period. SWAPIN and IO are the percentages of time the thread spent respectively
while swapping in and waiting on I/O more generally. PRIO is the I/O priority at
which the thread is running (set using the ionice command).

Controls: left and right arrows to change the sorting column, r to invert the
sorting order, o to toggle the --only option, p to toggle the --processes
option, a to toggle the --accumulated option, i to change I/O priority, q to
quit, any other key to force a refresh.''' % sys.argv[0]

def main(interface):
    try:
        locale.setlocale(locale.LC_ALL, '')
    except locale.Error:
        print('unable to set locale, falling back to the default locale')
    parser = optparse.OptionParser(usage=USAGE, version='iotop ' + VERSION)
    parser.add_option('-o', '--only', action='store_true',
                      dest='only', default=False,
                      help='only show processes or threads actually doing I/O')
    parser.add_option('-b', '--batch', action='store_true', dest='batch',
                      help='non-interactive mode')
    parser.add_option('-n', '--iter', type='int', dest='iterations',
                      metavar='NUM',
                      help='number of iterations before ending [infinite]')
    parser.add_option('-d', '--delay', type='float', dest='delay_seconds',
                      help='delay between iterations [1 second]',
                      metavar='SEC', default=1)
    parser.add_option('-p', '--pid', type='int', dest='pids', action='append',
                      help='processes/threads to monitor [all]', metavar='PID')
    parser.add_option('-u', '--user', type='str', dest='users', action='append',
                      help='users to monitor [all]', metavar='USER')
    parser.add_option('-P', '--processes', action='store_true',
                      dest='processes', default=False,
                      help='only show processes, not all threads')
    parser.add_option('-a', '--accumulated', action='store_true',
                      dest='accumulated', default=False,
                      help='show accumulated I/O instead of bandwidth')
    parser.add_option('-k', '--kilobytes', action='store_true',
                      dest='kilobytes', default=False,
                      help='use kilobytes instead of a human friendly unit')
    parser.add_option('-t', '--time', action='store_true', dest='time',
                      help='add a timestamp on each line (implies --batch)')
    parser.add_option('-q', '--quiet', action='count', dest='quiet', default=0,
                      help='suppress some lines of header (implies --batch)')
    parser.add_option('--profile', action='store_true', dest='profile',
                      default=False, help=optparse.SUPPRESS_HELP)

    options, args = parser.parse_args()
    if args:
        parser.error('Unexpected arguments: ' + ' '.join(args))
    find_uids(options)
    options.pids = options.pids or []
    options.batch = options.batch or options.time or options.quiet
#    options.batch = 1

    main_loop = lambda: run_iotop(options, interface)
#    print ("options:", options)
    #options: {'profile': False, 'delay_seconds': 1, 'users': None, 'processes': False, 'batch': 0, 'only': False, 'quiet': 0, 'iterations': None, 'time': None, 'accumulated': False, 'pids': [], 'kilobytes': False, 'uids': []}
#    if options.profile:
#        def safe_main_loop():
#            try:
#                main_loop()
#            except:
#                pass
#        _profile(safe_main_loop)
#    else:
    main_loop()

INTERFACE = "com.kylin.iomonitor"
PATH = "/com/kylin/iomonitor"
HOME = os.path.expandvars('$HOME')


class Daemon(dbus.service.Object):
    def __init__ (self, mainloop):
        '''
        dbus进程初始化
        '''
        bus_name = dbus.service.BusName(INTERFACE, bus=dbus.SystemBus())
        dbus.service.Object.__init__(self, bus_name, PATH)
        self.mainloop = mainloop

    @dbus.service.method(INTERFACE, in_signature='', out_signature='')
    def startWork(self):
        print ("#####startWork")
        t = threading.Thread(target = main, args = (self, ))
#        t.setDaemaon(True)
        t.start()

#        main(self)

    @dbus.service.method(INTERFACE, in_signature='', out_signature='')
    def quit(self):
        '''
        dbus退出函数
        '''
#        m_running = False
        self.mainloop.quit()
        sys.exit(0)

    @dbus.service.method(INTERFACE, in_signature='', out_signature='s')
    def test(self):
        '''
        一个dbus的测试函数
        '''
        return "kylin"

    @dbus.service.signal(INTERFACE, signature='as')
    def sendIoInfos(self, msg):
        pass

    @dbus.service.signal(INTERFACE, signature='ssss')
    def sendTotalAndActual(self, totalRead, totalWrite, actualRead, actualWrite):
        pass

def exit_process(*args, **kwargs):
#    print("exit_process")
#    m_running = False
    sys.exit(0)

if __name__ == '__main__':
    '''
    主函数   使用#echo $LANG或#locale查看当前系统语言环境
    '''
    ioaccounting = os.path.exists('/proc/self/io')

    try:
        vmstat_f = VmStat()
    except:
        vm_event_counters = False
    else:
        vm_event_counters = True

    if not ioaccounting or not vm_event_counters:
        print('Could not run iotop as some of the requirements are not met:')
        print('- Linux >= 2.6.20 with')
        if not ioaccounting:
            print('  - I/O accounting support ' \
              '(CONFIG_TASKSTATS, CONFIG_TASK_DELAY_ACCT, ' \
              'CONFIG_TASK_IO_ACCOUNTING)')
        if not vm_event_counters:
            print('  - VM event counters (CONFIG_VM_EVENT_COUNTERS)')
        sys.exit(1)
    else:
        print ("support iotop")
        dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
        GObject.threads_init()
        mainloop = GObject.MainLoop()
        signal.signal(signal.SIGINT, lambda : mainloop.quit())
        signal.signal(signal.SIGINT, exit_process)
        signal.signal(signal.SIGTERM, exit_process)
        Daemon(mainloop)
        mainloop.run()



#if __name__ == '__main__':

#    #
#    # Check for requirements:
#    #   o Linux >= 2.6.20 with I/O accounting and VM event counters
#    #

#    ioaccounting = os.path.exists('/proc/self/io')

#    try:
#        vmstat_f = VmStat()
#    except:
#        vm_event_counters = False
#    else:
#        vm_event_counters = True

#    if not ioaccounting or not vm_event_counters:
#        print('Could not run iotop as some of the requirements are not met:')
#        print('- Linux >= 2.6.20 with')
#        if not ioaccounting:
#            print('  - I/O accounting support ' \
#              '(CONFIG_TASKSTATS, CONFIG_TASK_DELAY_ACCT, ' \
#              'CONFIG_TASK_IO_ACCOUNTING)')
#        if not vm_event_counters:
#            print('  - VM event counters (CONFIG_VM_EVENT_COUNTERS)')
#        sys.exit(1)
#    else:
#        print ("support iotop")


##    try:
##        locale.setlocale(locale.LC_ALL, '')
##    except locale.Error:
##        print('unable to set locale, falling back to the default locale')
##    # set default value
##    options = {}
##    options.profile = False
##    options.delay_seconds = 1
##    options.users = None
##    options.delay_seconds = 1
##    options.processes = False
##    options.batch = 0
##    options.only = False
##    options.quiet = 0
##    options.iterations = None
##    options.time = None
##    options.accumulated = False
##    options.pids = []
##    options.kilobytes = False
##    options.uids = []
##    main_loop = lambda: run_iotop(options)
##    main_loop()

#    main()
